<?php

namespace DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\PriceCompare\ProductFields\GMC;

use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\ProductFields\ProductField;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\ProductFields\ProductFieldXml;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\ProductFields\ProductFieldStringValue;
use DOMElement;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\PriceCompare\ProductFields\CustomProductField;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\ProductFields\ProductFieldValue;
class UnitPricingProductField extends CustomProductField implements ProductField, ProductFieldXml
{
    public const TAG_NAME = 'g:unit_pricing_measure';
    private string $field_name;
    private ProductFieldValue $product_value;
    public function __construct(ProductFieldValue $product_value)
    {
        $this->product_value = $product_value;
    }
    public static function is_optional(): bool
    {
        return \true;
    }
    public static function is_allowed_to_change(): bool
    {
        return \true;
    }
    public static function get_default_field_name(): string
    {
        return 'unit_pricing_measure';
    }
    public static function get_default_field_nice_name(): string
    {
        return sprintf(esc_html__('Unit pricing measure %s', 'dropshipping-export-free'), '(' . self::TAG_NAME . ')');
    }
    public function get_field_name(): string
    {
        $default = self::get_default_field_name();
        return !empty($this->field_name) ? $this->field_name : $default;
    }
    public function set_field_name(string $string)
    {
        $this->field_name = trim($string);
    }
    public function map_xml_value(DOMElement $element): DOMElement
    {
        $root = $element->ownerDocument;
        $value = $this->get_values_as_string($this->product_value);
        if (\is_string($value)) {
            $name = $element->appendChild($root->createElement(self::TAG_NAME));
            $name->appendChild($root->createCDATASection($value));
        }
        return $element;
    }
}
